KUBERNETES(1)

NAME

kube-controller-manager -

SYNOPSIS

kube-controller-manager [OPTIONS]

DESCRIPTION

The Kubernetes controller manager is a daemon that embeds the core control loops shipped with Kubernetes. In applications of robotics and automation, a control loop is a non-terminating loop that regulates the state of the system. In Kubernetes, a controller is a control loop that watches the shared state of the cluster through the apiserver and makes changes attempting to move the current state towards the desired state. Examples of controllers that ship with Kubernetes today are the replication controller, endpoints controller, namespace controller, and serviceaccounts controller.

OPTIONS

--address=0.0.0.0
    The IP address on which to serve the insecure --port (set to 0.0.0.0 for all IPv4 interfaces and :: for all IPv6 interfaces).

--allocate-node-cidrs=false
    Should CIDRs for Pods be allocated and set on the cloud provider.

--allow-untagged-cloud=false
    Allow the cluster to run without the cluster-id on cloud instances. This is a legacy mode of operation and a cluster-id will be required in the future.

--alsologtostderr=false
    log to standard error as well as files

--attach-detach-reconcile-sync-period=1m0s
    The reconciler sync wait time between volume attach detach. This duration must be larger than one second, and increasing this value from the default may allow for volumes to be mismatched with pods.

--authentication-kubeconfig=""
    kubeconfig file pointing at the 'core' kubernetes server with enough rights to create tokenaccessreviews.authentication.k8s.io. This is optional. If empty, all token requests are considered to be anonymous and no client CA is looked up in the cluster.

--authentication-skip-lookup=false
    If false, the authentication-kubeconfig will be used to lookup missing authentication configuration from the cluster.

--authentication-token-webhook-cache-ttl=10s
    The duration to cache responses from the webhook token authenticator.

--authentication-tolerate-lookup-failure=false
    If true, failures to look up missing authentication configuration from the cluster are not considered fatal. Note that this can result in authentication that treats all requests as anonymous.

--authorization-always-allow-paths=[/healthz]
    A list of HTTP paths to skip during authorization, i.e. these are authorized without contacting the 'core' kubernetes server.

--authorization-kubeconfig=""
    kubeconfig file pointing at the 'core' kubernetes server with enough rights to create subjectaccessreviews.authorization.k8s.io. This is optional. If empty, all requests not skipped by authorization are forbidden.

--authorization-webhook-cache-authorized-ttl=10s
    The duration to cache 'authorized' responses from the webhook authorizer.

--authorization-webhook-cache-unauthorized-ttl=10s
    The duration to cache 'unauthorized' responses from the webhook authorizer.

--azure-container-registry-config=""
    Path to the file containing Azure container registry configuration information.

--bind-address=0.0.0.0
    The IP address on which to listen for the --secure-port port. The associated interface(s) must be reachable by the rest of the cluster, and by CLI/web clients. If blank, all interfaces will be used (0.0.0.0 for all IPv4 interfaces and :: for all IPv6 interfaces).

--cert-dir=""
    The directory where the TLS certs are located. If --tls-cert-file and --tls-private-key-file are provided, this flag will be ignored.

--cidr-allocator-type="RangeAllocator"
    Type of CIDR allocator to use

--client-ca-file=""
    If set, any request presenting a client certificate signed by one of the authorities in the client-ca-file is authenticated with an identity corresponding to the CommonName of the client certificate.

--cloud-config=""
    The path to the cloud provider configuration file. Empty string for no configuration file.

--cloud-provider=""
    The provider for cloud services. Empty string for no provider.

--cloud-provider-gce-lb-src-cidrs=130.211.0.0/22,209.85.152.0/22,209.85.204.0/22,35.191.0.0/16
    CIDRs opened in GCE firewall for LB traffic proxy health checks

--cluster-cidr=""
    CIDR Range for Pods in cluster. Requires --allocate-node-cidrs to be true

--cluster-name="kubernetes"
    The instance prefix for the cluster.

--cluster-signing-cert-file="/etc/kubernetes/ca/ca.pem"
    Filename containing a PEM-encoded X509 CA certificate used to issue cluster-scoped certificates

--cluster-signing-key-file="/etc/kubernetes/ca/ca.key"
    Filename containing a PEM-encoded RSA or ECDSA private key used to sign cluster-scoped certificates

--concurrent-deployment-syncs=5
    The number of deployment objects that are allowed to sync concurrently. Larger number = more responsive deployments, but more CPU (and network) load

--concurrent-endpoint-syncs=5
    The number of endpoint syncing operations that will be done concurrently. Larger number = faster endpoint updating, but more CPU (and network) load

--concurrent-gc-syncs=20
    The number of garbage collector workers that are allowed to sync concurrently.

--concurrent-namespace-syncs=10
    The number of namespace objects that are allowed to sync concurrently. Larger number = more responsive namespace termination, but more CPU (and network) load

--concurrent-replicaset-syncs=5
    The number of replica sets that are allowed to sync concurrently. Larger number = more responsive replica management, but more CPU (and network) load

--concurrent-resource-quota-syncs=5
    The number of resource quotas that are allowed to sync concurrently. Larger number = more responsive quota management, but more CPU (and network) load

--concurrent-service-syncs=1
    The number of services that are allowed to sync concurrently. Larger number = more responsive service management, but more CPU (and network) load

--concurrent-serviceaccount-token-syncs=5
    The number of service account token objects that are allowed to sync concurrently. Larger number = more responsive token generation, but more CPU (and network) load

--concurrent-ttl-after-finished-syncs=5
    The number of TTL-after-finished controller workers that are allowed to sync concurrently.

--concurrent_rc_syncs=5
    The number of replication controllers that are allowed to sync concurrently. Larger number = more responsive replica management, but more CPU (and network) load

--configure-cloud-routes=true
    Should CIDRs allocated by allocate-node-cidrs be configured on the cloud provider.

--contention-profiling=false
    Enable lock contention profiling, if profiling is enabled

--controller-start-interval=0s
    Interval between starting controller managers.

--controllers=[]
    A list of controllers to enable. '' enables all on-by-default controllers, 'foo' enables the controller named 'foo', '-foo' disables the controller named 'foo'. All controllers: attachdetach, bootstrapsigner, cloud-node-lifecycle, clusterrole-aggregation, cronjob, csrapproving, csrcleaner, csrsigning, daemonset, deployment, disruption, endpoint, garbagecollector, horizontalpodautoscaling, job, namespace, nodeipam, nodelifecycle, persistentvolume-binder, persistentvolume-expander, podgc, pv-protection, pvc-protection, replicaset, replicationcontroller, resourcequota, root-ca-cert-publisher, route, service, serviceaccount, serviceaccount-token, statefulset, tokencleaner, ttl, ttl-after-finished Disabled-by-default controllers: bootstrapsigner, tokencleaner

--deleting-pods-burst=0
    Number of nodes on which pods are bursty deleted in case of node failure. For more details look into RateLimiter.

--deleting-pods-qps=0.1
    Number of nodes per second on which pods are deleted in case of node failure.

--deployment-controller-sync-period=30s
    Period for syncing the deployments.

--disable-attach-detach-reconcile-sync=false
    Disable volume attach detach reconciler sync. Disabling this may cause volumes to be mismatched with pods. Use wisely.

--enable-dynamic-provisioning=true
    Enable dynamic provisioning for environments that support it.

--enable-garbage-collector=true
    Enables the generic garbage collector. MUST be synced with the corresponding flag of the kube-apiserver.

--enable-hostpath-provisioner=false
    Enable HostPath PV provisioning when running without a cloud provider. This allows testing and development of provisioning features. HostPath provisioning is not supported in any way, won't work in a multi-node cluster, and should not be used for anything other than testing or development.

--enable-taint-manager=true
    WARNING: Beta feature. If set to true enables NoExecute Taints and will evict all not-tolerating Pod running on Nodes tainted with this kind of Taints.

--experimental-cluster-signing-duration=8760h0m0s
    The length of duration signed certificates will be given.

--external-cloud-volume-plugin=""
    The plugin to use when cloud provider is set to external. Can be empty, should only be set when cloud-provider is external. Currently used to allow node and volume controllers to work for in tree cloud providers.

--feature-gates=
    A set of key=value pairs that describe feature gates for alpha/experimental features. Options are: APIListChunking=true|false (BETA - default=true) APIResponseCompression=true|false (ALPHA - default=false) AllAlpha=true|false (ALPHA - default=false) AppArmor=true|false (BETA - default=true) AttachVolumeLimit=true|false (BETA - default=true) BalanceAttachedNodeVolumes=true|false (ALPHA - default=false) BlockVolume=true|false (BETA - default=true) BoundServiceAccountTokenVolume=true|false (ALPHA - default=false) CPUManager=true|false (BETA - default=true) CRIContainerLogRotation=true|false (BETA - default=true) CSIBlockVolume=true|false (BETA - default=true) CSIDriverRegistry=true|false (BETA - default=true) CSIInlineVolume=true|false (ALPHA - default=false) CSIMigration=true|false (ALPHA - default=false) CSIMigrationAWS=true|false (ALPHA - default=false) CSIMigrationGCE=true|false (ALPHA - default=false) CSIMigrationOpenStack=true|false (ALPHA - default=false) CSINodeInfo=true|false (BETA - default=true) CustomCPUCFSQuotaPeriod=true|false (ALPHA - default=false) CustomResourcePublishOpenAPI=true|false (ALPHA - default=false) CustomResourceSubresources=true|false (BETA - default=true) CustomResourceValidation=true|false (BETA - default=true) CustomResourceWebhookConversion=true|false (ALPHA - default=false) DebugContainers=true|false (ALPHA - default=false) DevicePlugins=true|false (BETA - default=true) DryRun=true|false (BETA - default=true) DynamicAuditing=true|false (ALPHA - default=false) DynamicKubeletConfig=true|false (BETA - default=true) ExpandCSIVolumes=true|false (ALPHA - default=false) ExpandInUsePersistentVolumes=true|false (ALPHA - default=false) ExpandPersistentVolumes=true|false (BETA - default=true) ExperimentalCriticalPodAnnotation=true|false (ALPHA - default=false) ExperimentalHostUserNamespaceDefaulting=true|false (BETA - default=false) HyperVContainer=true|false (ALPHA - default=false) KubeletPodResources=true|false (ALPHA - default=false) LocalStorageCapacityIsolation=true|false (BETA - default=true) MountContainers=true|false (ALPHA - default=false) NodeLease=true|false (BETA - default=true) PodShareProcessNamespace=true|false (BETA - default=true) ProcMountType=true|false (ALPHA - default=false) QOSReserved=true|false (ALPHA - default=false) ResourceLimitsPriorityFunction=true|false (ALPHA - default=false) ResourceQuotaScopeSelectors=true|false (BETA - default=true) RotateKubeletClientCertificate=true|false (BETA - default=true) RotateKubeletServerCertificate=true|false (BETA - default=true) RunAsGroup=true|false (BETA - default=true) RuntimeClass=true|false (BETA - default=true) SCTPSupport=true|false (ALPHA - default=false) ScheduleDaemonSetPods=true|false (BETA - default=true) ServerSideApply=true|false (ALPHA - default=false) ServiceNodeExclusion=true|false (ALPHA - default=false) StorageVersionHash=true|false (ALPHA - default=false) StreamingProxyRedirects=true|false (BETA - default=true) SupportNodePidsLimit=true|false (ALPHA - default=false) SupportPodPidsLimit=true|false (BETA - default=true) Sysctls=true|false (BETA - default=true) TTLAfterFinished=true|false (ALPHA - default=false) TaintBasedEvictions=true|false (BETA - default=true) TaintNodesByCondition=true|false (BETA - default=true) TokenRequest=true|false (BETA - default=true) TokenRequestProjection=true|false (BETA - default=true) ValidateProxyRedirects=true|false (BETA - default=true) VolumeSnapshotDataSource=true|false (ALPHA - default=false) VolumeSubpathEnvExpansion=true|false (ALPHA - default=false) WinDSR=true|false (ALPHA - default=false) WinOverlay=true|false (ALPHA - default=false) WindowsGMSA=true|false (ALPHA - default=false)

--flex-volume-plugin-dir="/usr/libexec/kubernetes/kubelet-plugins/volume/exec/"
    Full path of the directory in which the flex volume plugin should search for additional third party volume plugins.

-h, --help=false
    help for kube-controller-manager

--horizontal-pod-autoscaler-cpu-initialization-period=5m0s
    The period after pod start when CPU samples might be skipped.

--horizontal-pod-autoscaler-downscale-delay=5m0s
    The period since last downscale, before another downscale can be performed in horizontal pod autoscaler.

--horizontal-pod-autoscaler-downscale-stabilization=5m0s
    The period for which autoscaler will look backwards and not scale down below any recommendation it made during that period.

--horizontal-pod-autoscaler-initial-readiness-delay=30s
    The period after pod start during which readiness changes will be treated as initial readiness.

--horizontal-pod-autoscaler-sync-period=15s
    The period for syncing the number of pods in horizontal pod autoscaler.

--horizontal-pod-autoscaler-tolerance=0.1
    The minimum change (from 1.0) in the desired-to-actual metrics ratio for the horizontal pod autoscaler to consider scaling.

--horizontal-pod-autoscaler-upscale-delay=3m0s
    The period since last upscale, before another upscale can be performed in horizontal pod autoscaler.

--horizontal-pod-autoscaler-use-rest-clients=true
    If set to true, causes the horizontal pod autoscaler controller to use REST clients through the kube-aggregator, instead of using the legacy metrics client through the API server proxy. This is required for custom metrics support in the horizontal pod autoscaler.

--http2-max-streams-per-connection=0
    The limit that the server gives to clients for the maximum number of streams in an HTTP/2 connection. Zero means to use golang's default.

--kube-api-burst=30
    Burst to use while talking with kubernetes apiserver.

--kube-api-content-type="application/vnd.kubernetes.protobuf"
    Content type of requests sent to apiserver.

--kube-api-qps=20
    QPS to use while talking with kubernetes apiserver.

--kubeconfig=""
    Path to kubeconfig file with authorization and master location information.

--large-cluster-size-threshold=50
    Number of nodes from which NodeController treats the cluster as large for the eviction logic purposes. --secondary-node-eviction-rate is implicitly overridden to 0 for clusters this size or smaller.

--leader-elect=true
    Start a leader election client and gain leadership before executing the main loop. Enable this when running replicated components for high availability.

--leader-elect-lease-duration=15s
    The duration that non-leader candidates will wait after observing a leadership renewal until attempting to acquire leadership of a led but unrenewed leader slot. This is effectively the maximum duration that a leader can be stopped before it is replaced by another candidate. This is only applicable if leader election is enabled.

--leader-elect-renew-deadline=10s
    The interval between attempts by the acting master to renew a leadership slot before it stops leading. This must be less than or equal to the lease duration. This is only applicable if leader election is enabled.

--leader-elect-resource-lock="endpoints"
    The type of resource object that is used for locking during leader election. Supported options are endpoints (default) and configmaps.

--leader-elect-retry-period=2s
    The duration the clients should wait between attempting acquisition and renewal of a leadership. This is only applicable if leader election is enabled.

--log-backtrace-at=:0
    when logging hits line file:N, emit a stack trace

--log-dir=""
    If non-empty, write log files in this directory

--log-file=""
    If non-empty, use this log file

--log-flush-frequency=5s
    Maximum number of seconds between log flushes

--logtostderr=true
    log to standard error instead of files

--master=""
    The address of the Kubernetes API server (overrides any value in kubeconfig).

--min-resync-period=12h0m0s
    The resync period in reflectors will be random between MinResyncPeriod and 2*MinResyncPeriod.

--namespace-sync-period=5m0s
    The period for syncing namespace life-cycle updates

--node-cidr-mask-size=24
    Mask size for node cidr in cluster.

--node-eviction-rate=0.1
    Number of nodes per second on which pods are deleted in case of node failure when a zone is healthy (see --unhealthy-zone-threshold for definition of healthy/unhealthy). Zone refers to entire cluster in non-multizone clusters.

--node-monitor-grace-period=40s
    Amount of time which we allow running Node to be unresponsive before marking it unhealthy. Must be N times more than kubelet's nodeStatusUpdateFrequency, where N means number of retries allowed for kubelet to post node status.

--node-monitor-period=5s
    The period for syncing NodeStatus in NodeController.

--node-startup-grace-period=1m0s
    Amount of time which we allow starting Node to be unresponsive before marking it unhealthy.

--node-sync-period=0s
    This flag is deprecated and will be removed in future releases. See node-monitor-period for Node health checking or route-reconciliation-period for cloud provider's route configuration settings.

--pod-eviction-timeout=5m0s
    The grace period for deleting pods on failed nodes.

--port=10252
    The port on which to serve unsecured, unauthenticated access. Set to 0 to disable.

--profiling=false
    Enable profiling via web interface host:port/debug/pprof/

--pv-recycler-increment-timeout-nfs=30
    the increment of time added per Gi to ActiveDeadlineSeconds for an NFS scrubber pod

--pv-recycler-minimum-timeout-hostpath=60
    The minimum ActiveDeadlineSeconds to use for a HostPath Recycler pod. This is for development and testing only and will not work in a multi-node cluster.

--pv-recycler-minimum-timeout-nfs=300
    The minimum ActiveDeadlineSeconds to use for an NFS Recycler pod

--pv-recycler-pod-template-filepath-hostpath=""
    The file path to a pod definition used as a template for HostPath persistent volume recycling. This is for development and testing only and will not work in a multi-node cluster.

--pv-recycler-pod-template-filepath-nfs=""
    The file path to a pod definition used as a template for NFS persistent volume recycling

--pv-recycler-timeout-increment-hostpath=30
    the increment of time added per Gi to ActiveDeadlineSeconds for a HostPath scrubber pod. This is for development and testing only and will not work in a multi-node cluster.

--pvclaimbinder-sync-period=15s
    The period for syncing persistent volumes and persistent volume claims

--register-retry-count=10
    The number of retries for initial node registration. Retry interval equals node-sync-period.

--requestheader-allowed-names=[]
    List of client certificate common names to allow to provide usernames in headers specified by --requestheader-username-headers. If empty, any client certificate validated by the authorities in --requestheader-client-ca-file is allowed.

--requestheader-client-ca-file=""
    Root certificate bundle to use to verify client certificates on incoming requests before trusting usernames in headers specified by --requestheader-username-headers. WARNING: generally do not depend on authorization being already done for incoming requests.

--requestheader-extra-headers-prefix=[x-remote-extra-]
    List of request header prefixes to inspect. X-Remote-Extra- is suggested.

--requestheader-group-headers=[x-remote-group]
    List of request headers to inspect for groups. X-Remote-Group is suggested.

--requestheader-username-headers=[x-remote-user]
    List of request headers to inspect for usernames. X-Remote-User is common.

--resource-quota-sync-period=5m0s
    The period for syncing quota usage status in the system

--root-ca-file=""
    If set, this root certificate authority will be included in service account's token secret. This must be a valid PEM-encoded CA bundle.

--route-reconciliation-period=10s
    The period for reconciling routes created for Nodes by cloud provider.

--secondary-node-eviction-rate=0.01
    Number of nodes per second on which pods are deleted in case of node failure when a zone is unhealthy (see --unhealthy-zone-threshold for definition of healthy/unhealthy). Zone refers to entire cluster in non-multizone clusters. This value is implicitly overridden to 0 if the cluster size is smaller than --large-cluster-size-threshold.

--secure-port=10257
    The port on which to serve HTTPS with authentication and authorization.If 0, don't serve HTTPS at all.

--service-account-private-key-file=""
    Filename containing a PEM-encoded private RSA or ECDSA key used to sign service account tokens.

--service-cluster-ip-range=""
    CIDR Range for Services in cluster. Requires --allocate-node-cidrs to be true

--skip-headers=false
    If true, avoid header prefixes in the log messages

--stderrthreshold=2
    logs at or above this threshold go to stderr

--terminated-pod-gc-threshold=12500
    Number of terminated pods that can exist before the terminated pod garbage collector starts deleting terminated pods. If <= 0, the terminated pod garbage collector is disabled.

--tls-cert-file=""
    File containing the default x509 Certificate for HTTPS. (CA cert, if any, concatenated after server cert). If HTTPS serving is enabled, and --tls-cert-file and --tls-private-key-file are not provided, a self-signed certificate and key are generated for the public address and saved to the directory specified by --cert-dir.

--tls-cipher-suites=[]
    Comma-separated list of cipher suites for the server. If omitted, the default Go cipher suites will be use. Possible values: TLS_ECDHE_ECDSA_WITH_AES_128_CBC_SHA,TLS_ECDHE_ECDSA_WITH_AES_128_CBC_SHA256,TLS_ECDHE_ECDSA_WITH_AES_128_GCM_SHA256,TLS_ECDHE_ECDSA_WITH_AES_256_CBC_SHA,TLS_ECDHE_ECDSA_WITH_AES_256_GCM_SHA384,TLS_ECDHE_ECDSA_WITH_CHACHA20_POLY1305,TLS_ECDHE_ECDSA_WITH_RC4_128_SHA,TLS_ECDHE_RSA_WITH_3DES_EDE_CBC_SHA,TLS_ECDHE_RSA_WITH_AES_128_CBC_SHA,TLS_ECDHE_RSA_WITH_AES_128_CBC_SHA256,TLS_ECDHE_RSA_WITH_AES_128_GCM_SHA256,TLS_ECDHE_RSA_WITH_AES_256_CBC_SHA,TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384,TLS_ECDHE_RSA_WITH_CHACHA20_POLY1305,TLS_ECDHE_RSA_WITH_RC4_128_SHA,TLS_RSA_WITH_3DES_EDE_CBC_SHA,TLS_RSA_WITH_AES_128_CBC_SHA,TLS_RSA_WITH_AES_128_CBC_SHA256,TLS_RSA_WITH_AES_128_GCM_SHA256,TLS_RSA_WITH_AES_256_CBC_SHA,TLS_RSA_WITH_AES_256_GCM_SHA384,TLS_RSA_WITH_RC4_128_SHA

--tls-min-version=""
    Minimum TLS version supported. Possible values: VersionTLS10, VersionTLS11, VersionTLS12

--tls-private-key-file=""
    File containing the default x509 private key matching --tls-cert-file.

--tls-sni-cert-key=[]
    A pair of x509 certificate and private key file paths, optionally suffixed with a list of domain patterns which are fully qualified domain names, possibly with prefixed wildcard segments. If no domain patterns are provided, the names of the certificate are extracted. Non-wildcard matches trump over wildcard matches, explicit domain patterns trump over extracted names. For multiple key/certificate pairs, use the --tls-sni-cert-key multiple times. Examples: "example.crt,example.key" or "foo.crt,foo.key:*.foo.com,foo.com".

--unhealthy-zone-threshold=0.55
    Fraction of Nodes in a zone which needs to be not Ready (minimum 3) for zone to be treated as unhealthy.

--use-service-account-credentials=false
    If true, use individual service account credentials for each controller.

-v, --v=0
    number for the log level verbosity

--version=false
    Print version information and quit

--vmodule=
    comma-separated list of pattern=N settings for file-filtered logging

HISTORY

January 2015, Originally compiled by Eric Paris (eparis at redhat dot com) based on the kubernetes source material, but hopefully they have been automatically generated since!